]> git.madduck.net Git - code/myrepos.git/commitdiff

madduck's git repository

Every one of the projects in this repository is available at the canonical URL git://git.madduck.net/madduck/pub/<projectpath> — see each project's metadata for the exact URL.

All patches and comments are welcome. Please squash your changes to logical commits before using git-format-patch and git-send-email to patches@git.madduck.net. If you'd read over the Git project's submission guidelines and adhered to them, I'd be especially grateful.

SSH access, as well as push access can be individually arranged.

If you use my repositories frequently, consider adding the following snippet to ~/.gitconfig and using the third clone URL listed for each project:

[url "git://git.madduck.net/madduck/"]
  insteadOf = madduck:

Merge branch 'master' of git://git.madduck.net/code/mr
authorJoey Hess <joey@kodama.kitenet.net>
Fri, 26 Oct 2007 07:40:54 +0000 (03:40 -0400)
committerJoey Hess <joey@kodama.kitenet.net>
Fri, 26 Oct 2007 07:40:54 +0000 (03:40 -0400)
debian/changelog
mr

index 5631d7f253c463aee9354c6c0b4956f27579adac..11e15b1af741a141625fb79fbee6037266bad6d7 100644 (file)
@@ -1,4 +1,4 @@
-mr (0.9) UNRELEASED; urgency=low
+mr (0.9) unstable; urgency=low
 
   * Split up actions, so each rcs has its own set of action commands,
     and mr tests to see what rcs is used by a repository, and dispatches
@@ -28,7 +28,7 @@ mr (0.9) UNRELEASED; urgency=low
     type and use includes, and partly because it's currently too ugly to be
     in mr itself due to bugs and limitations in git.
 
- -- Joey Hess <joeyh@debian.org>  Fri, 26 Oct 2007 01:08:11 -0400
+ -- Joey Hess <joeyh@debian.org>  Fri, 26 Oct 2007 03:00:40 -0400
 
 mr (0.8) unstable; urgency=low
 
diff --git a/mr b/mr
index 2187aa06b59472cc9c13dfe5367bdd9b4ef59b45..bc73d4023353ec8c69accc848a1cdbe88e9b7394 100755 (executable)
--- a/mr
+++ b/mr
@@ -296,7 +296,8 @@ use warnings;
 use strict;
 use Getopt::Long;
 use Cwd qw(getcwd abs_path);
-use POSIX "WNOHANG";
+
+# things that can happen when mr runs a command
 use constant {
        OK => 0,
        FAILED => 1,
@@ -304,62 +305,23 @@ use constant {
        ABORT => 3,
 };
 
-$SIG{INT}=sub {
-       print STDERR "mr: interrupted\n";
-       exit 2;
-};
-
-$ENV{MR_CONFIG}="$ENV{HOME}/.mrconfig";
+# configurables
 my $config_overridden=0;
 my $verbose=0;
 my $stats=0;
 my $no_recurse=0;
 my $no_chdir=0;
 my $jobs=1;
+my $directory=getcwd();
+
+# globals :-(
 my %config;
 my %configfiles;
 my %knownactions;
 my %alias;
-my $directory=getcwd();
 my (@ok, @failed, @skipped);
 
-getopts();
-
-# This can happen if it's run in a directory that was removed
-# or other strangeness.
-if (! defined $directory) {
-       die("mr: failed to determine working directory\n");
-}
-# Make sure MR_CONFIG is an absolute path, but don't use abs_path since
-# the config file might be a symlink to elsewhere, and the directory it's
-# in is significant.
-if ($ENV{MR_CONFIG} !~ /^\//) {
-       $ENV{MR_CONFIG}=getcwd()."/".$ENV{MR_CONFIG};
-}
-# Try to set MR_PATH to the path to the program.
-eval {
-       use FindBin qw($Bin $Script);
-       $ENV{MR_PATH}=$Bin."/".$Script;
-};
-
-loadconfig(\*DATA);
-loadconfig($ENV{MR_CONFIG});
-#use Data::Dumper;
-#print Dumper(\%config);
-
-my $action=expandaction(shift @ARGV);
-dispatch($action);
-showstats($action);
-
-if (@failed) {
-       exit 1;
-}
-elsif (! @ok && @skipped) {
-       exit 1;
-}
-else {
-       exit 0;
-}
+main();
 
 sub dispatch { #{{{
        my $action=shift;
@@ -635,6 +597,7 @@ sub record { #{{{
 } #}}}
 
 sub showstats { #{{{
+       my $action=shift;
        if (! @ok && ! @failed && ! @skipped) {
                die "mr $action: no repositories found to work on\n";
        }
@@ -830,11 +793,11 @@ sub loadconfig { #{{{
                                        my $ret=system($value);
                                        if ($ret != 0) {
                                                if (($? & 127) == 2) {
-                                                       print STDERR "mr $action: chain test interrupted\n";
+                                                       print STDERR "mr: chain test interrupted\n";
                                                        exit 2;
                                                }
                                                elsif ($? & 127) {
-                                                       print STDERR "mr $action: chain test received signal ".($? & 127)."\n";
+                                                       print STDERR "mr: chain test received signal ".($? & 127)."\n";
                                                }
                                        }
                                        else {
@@ -951,7 +914,7 @@ sub modifyconfig { #{{{
 } #}}}
        
 sub help { #{{{
-       exec($config{''}{DEFAULT}{$action}) || die "exec: $!";
+       exec($config{''}{DEFAULT}{help}) || die "exec: $!";
 } #}}}
        
 sub config { #{{{
@@ -984,7 +947,7 @@ sub config { #{{{
                                }
                        }
                        if (! $found) {
-                               die "mr $action: $section $_ not set\n";
+                               die "mr config: $section $_ not set\n";
                        }
                }
        }
@@ -1009,21 +972,21 @@ sub register { #{{{
        if (@ARGV) {
                my $subdir=shift @ARGV;
                if (! chdir($subdir)) {
-                       print STDERR "mr $action: failed to chdir to $subdir: $!\n";
+                       print STDERR "mr register: failed to chdir to $subdir: $!\n";
                }
        }
 
        $ENV{MR_REPO}=getcwd();
        my $command=findcommand("register", $ENV{MR_REPO}, $directory, 'DEFAULT');
        if (! defined $command) {
-               die "mr $action: unknown repository type\n";
+               die "mr register: unknown repository type\n";
        }
 
        $ENV{MR_REPO}=~s/.*\/(.*)/$1/;
        $command="set -e; ".$config{$directory}{DEFAULT}{lib}."\n".
                "my_action(){ $command\n }; my_action ".
                join(" ", map { s/\//\/\//g; s/"/\"/g; '"'.$_.'"' } @ARGV);
-       print "mr $action: running >>$command<<\n" if $verbose;
+       print "mr register: running >>$command<<\n" if $verbose;
        exec($command) || die "exec: $!";
 } #}}}
 
@@ -1067,6 +1030,54 @@ sub getopts { #{{{
        }
 } #}}}
 
+sub init { #{{{
+       $SIG{INT}=sub {
+               print STDERR "mr: interrupted\n";
+               exit 2;
+       };
+       
+       $ENV{MR_CONFIG}="$ENV{HOME}/.mrconfig";
+
+       # This can happen if it's run in a directory that was removed
+       # or other strangeness.
+       if (! defined $directory) {
+               die("mr: failed to determine working directory\n");
+       }
+       # Make sure MR_CONFIG is an absolute path, but don't use abs_path since
+       # the config file might be a symlink to elsewhere, and the directory it's
+       # in is significant.
+       if ($ENV{MR_CONFIG} !~ /^\//) {
+               $ENV{MR_CONFIG}=getcwd()."/".$ENV{MR_CONFIG};
+       }
+       # Try to set MR_PATH to the path to the program.
+       eval {
+               use FindBin qw($Bin $Script);
+               $ENV{MR_PATH}=$Bin."/".$Script;
+       };
+} #}}}
+
+sub main { #{{{
+       getopts();
+       init();
+       loadconfig(\*DATA);
+       loadconfig($ENV{MR_CONFIG});
+       #use Data::Dumper; print Dumper(\%config);
+
+       my $action=expandaction(shift @ARGV);
+       dispatch($action);
+       showstats($action);
+
+       if (@failed) {
+               exit 1;
+       }
+       elsif (! @ok && @skipped) {
+               exit 1;
+       }
+       else {
+               exit 0;
+       }
+} #}}}
+
 # Finally, some useful actions that mr knows about by default.
 # These can be overridden in ~/.mrconfig.
 #DATA{{{